#!/bin/sh
malia=arm64
malig=aarch64-linux-gnu
malil=meson_gx_mali_450
malim=mali450
malis=meson
malit=20180418
maliv=r7p0

KDIR=$(pwd)/linux

buildmalideb() {
  malid=$1

  if [ ! -e ${malim}-${malid}-${malis} ]; then
    mkdir ${malim}-${malid}-${malis}
    cp -apP ${malim}-${malis}/DEBIAN ${malim}-${malid}-${malis}/
    sed -i s/${malim}-${malis}/${malim}-${malid}-${malis}/g ${malim}-${malid}-${malis}/DEBIAN/control
  fi

  cd ${malim}-${malid}-${malis}

  mkdir -p usr/lib/${malig}/${malim}-${malid}-${malis}

  if [ -e ../${malil}/lib_x11-${malid}/libUMP.so ]; then
    cp -p ../${malil}/lib_x11-${malid}/libMali.so usr/lib/${malig}/${malim}-${malid}-${malis}/
    cp -p ../${malil}/lib_x11-${malid}/libUMP.so  usr/lib/${malig}/${malim}-${malid}-${malis}/

  else
    cp -p ../${malil}/lib_${malid}/libMali.so usr/lib/${malig}/${malim}-${malid}-${malis}/
  fi

  mkdir -p usr/share/doc/${malim}-${malid}-${malis}
  cp -p ../${malil}/END_USER_LICENCE_AGREEMENT.txt usr/share/doc/${malim}-${malid}-${malis}/

  sed -i s/'Version: .*'/'Version: '${malit}-${maliv}-1/g DEBIAN/control

  cd ..

  dpkg-deb -b ${malim}-${malid}-${malis} ${malim}-${malid}-${malis}_${malit}-${maliv}-1_${malia}.deb
}

cd ${malil}/

if [ ! -e ${KDIR}/drivers/gpu/arm/mali ]; then
  ARCH=${malia} KDIR=$KDIR ./build.sh
fi

cd ..

cd ${malim}-${malis}

mkdir -p usr/lib/${malig}/${malim}-${malis}
cp -p ../${malil}/libMali.so usr/lib/${malig}/${malim}-${malis}/

mkdir -p usr/share/doc/${malim}-${malis}
cp -p ../${malil}/END_USER_LICENCE_AGREEMENT.txt usr/share/doc/${malim}-${malis}/

sed -i s/'Version: .*'/'Version: '${malit}-${maliv}-1/g DEBIAN/control

cd ..

dpkg-deb -b ${malim}-${malis} ${malim}-${malis}_${malit}-${maliv}-1_${malia}.deb

#buildmalideb wayland
buildmalideb wayland-fbdev
buildmalideb wayland-drm
buildmalideb fbdev
buildmalideb dummy

zip ${malim}-${malis}-gx-${maliv}-${malia}.zip \
  install-mali-driver.sh \
  ${malim}*-${malis}_${malit}-${maliv}-1_${malia}.deb \
  install-mali-dev.sh \
  mali450-meson-dev.tar.gz

echo OK
