#!/bin/sh

doOptional=false
useDebianSource=false

. ./build-env.sh

lxmmmkb=`echo ${lxdebkb} | cut -d '.' -f 1-2`

if [ ! -e linux-${lxmmmkb}.y ]; then
  git clone -b linux-${lxmmmkb}.y --depth 100 https://git.kernel.org/pub/scm/linux/kernel/git/stable/linux-stable.git linux-${lxmmmkb}.y
  #git clone --depth 100 https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git linux-${lxmmmkb}.y
fi

echo "Copying files from linux-${lxmmmkb}.y git..."
mkdir linux && \
cp -apP linux-${lxmmmkb}.y/. linux/ && \
cd linux

mkdir -p patches
mkdir -p patches/platform

for f in `cat ../patches/series-odroidc2 | grep -E '^platform/' | cut -d / -f 2-` ; do
  cp -p ../patches/${f} patches/platform/
done

cat ../patches/series-odroidc2 >> patches/series

if [ $doOptional = true ]; then
  for f in `cat ../patches/series-odroidc2-optional | grep -E '^platform/' | cut -d / -f 2-` ; do
    cp -p ../patches/${f} patches/platform/
  done

  cat ../patches/series-odroidc2-optional >> patches/series
fi

cp -p ../patches/stmmac_platform_mac_addr_set.patch patches/
echo "stmmac_platform_mac_addr_set.patch" >> patches/series

quilt push -a

if [ $doOptional = true ]; then
  for f in `cat ../patches/series-odroidc2-binary` ; do
    git apply ../patches/${f}
  done
fi

cp -p ../patches/*_defconfig arch/arm64/configs/

echo OK
