#!/bin/sh
maliv=r7p0

#brsub=buildroot_openlinux/buildroot/package/meson-mali
#brtgz=arm-buildroot-2016-08-18-5aaca1b35f.tar.gz
#brsub=buildroot_openlinux/buildroot/package/meson-mali
#brtgz=buildroot_openlinux_kernel_3.14_wayland_20170630.tar.gz
brsub=buildroot_openlinux_kernel_4.9_fbdev_20180418/vendor/amlogic/meson_mali
brtgz=buildroot_openlinux_kernel_4.9_fbdev_20180418.tar.gz

defcfg=arch/arm64/configs/odroidc2_defconfig

KDIR=$(pwd)/linux

mkdir -p archives

cd archives

if [ ! -e ${brtgz} -a ! -e ../meson-mali-lib ]; then
  #wget -N http://openlinux.amlogic.com:8000/download/ARM/filesystem/${brtgz}
  #wget -N http://openlinux2.amlogic.com:8000/download/ARM/filesystem/Linux_BSP/${brtgz}
  wget -N http://openlinux.amlogic.com:8000/download/ARM/filesystem/Linux_BSP/${brtgz}
fi

cd ..

if [ ! -e meson-mali-lib ]; then
  mkdir meson-mali-lib
  cd meson-mali-lib

  echo "Extracting meson mali lib from buildroot..."
  tar xzf ../archives/${brtgz} ${brsub}

  cd ..
fi

#if [ ! -e xf86-video-armsoc ]; then
#  git clone -b meson-drm https://github.com/superna9999/xf86-video-armsoc
#fi

if [ ! -e meson_gx_mali_450 ]; then
  #git clone -b DX910-SW-99002-r6p1-01rel0_meson_gx https://github.com/superna9999/meson_gx_mali_450
  git clone -b DX910-SW-99002-r7p0-00rel1_meson_gx https://github.com/superna9999/meson_gx_mali_450

  cd meson_gx_mali_450/

  mkdir -p patches/${maliv}
  for f in `cat ../patches/series-mali-${maliv} | grep -E "^${maliv}/" | cut -d / -f 2-` ; do
    cp -p ../patches/$f patches/${maliv}/
    echo "${maliv}/$f" >> patches/${maliv}/series
  done

  ##patch -p1 < ../meson_gx_mali_450-4.14-build.patch
  #patch -p1 < ../meson_gx_mali_450-4.14.patch

  mkdir -p driver/patches
  #cp -p patches/*.patch driver/patches/
  cp -apP patches/${maliv} driver/patches/
  mv driver/patches/${maliv}/series  driver/patches/
  cd driver/
  quilt push -a
  cd ..

else
  cd meson_gx_mali_450/
fi

cp -p ../patches/mali-lib-END_USER_LICENCE_AGREEMENT.txt ./END_USER_LICENCE_AGREEMENT.txt

#cp -p ../meson-mali-lib/${brsub}/lib/arm64/r6p1/m450-X/libMali.so .
#cp -p ../meson-mali-lib/${brsub}/lib/arm64/r7p0/m450-X/libMali.so .
cp -p ../meson-mali-lib/${brsub}/lib/arm64/m450-X/r7p0/libMali.so .

#mkdir -p lib_wayland
#cp -p ../meson-mali-lib/${brsub}/lib/arm64/r7p0/m450/wayland/libMali.so lib_wayland/

mkdir -p lib_wayland-drm
cp -p ../meson-mali-lib/${brsub}/lib/arm64/m450/r7p0/wayland/drm/libMali.so lib_wayland-drm/

mkdir -p lib_wayland-fbdev
cp -p ../meson-mali-lib/${brsub}/lib/arm64/m450/r7p0/wayland/fbdev/libMali.so lib_wayland-fbdev/

mkdir -p lib_fbdev
#cp -p ../meson-mali-lib/${brsub}/lib/arm64/r7p0/m450/libMali.so lib_fbdev/
cp -p ../meson-mali-lib/${brsub}/lib/arm64/m450/r7p0/fbdev/libMali.so lib_fbdev/

mkdir -p lib_dummy
cp -p ../meson-mali-lib/${brsub}/lib/arm64/m450/r7p0/dummy/libMali.so lib_dummy/

mkdir -p ../meson-mali-lib/${brsub}/patches
cp -p ../patches/mali-r7p0-dev-*.patch ../meson-mali-lib/${brsub}/patches/
cp -p ../patches/series-mali-r7p0-dev ../meson-mali-lib/${brsub}/patches/

cd ../meson-mali-lib/${brsub}/
tar czf mali450-meson-dev.tar.gz include lib/pkgconfig patches
cd -

mv ../meson-mali-lib/${brsub}/mali450-meson-dev.tar.gz ../

cd ..

if [ -e ${KDIR}/drivers/gpu ]; then
  echo "Integrating meson mali driver..."

  if [ ! -e ${KDIR}/drivers/gpu/arm/mali ]; then
    mkdir -p ${KDIR}/drivers/gpu/arm
    cp -apP meson_gx_mali_450/driver/src/devicedrv/mali ${KDIR}/drivers/gpu/arm/
    cp -apP meson_gx_mali_450/driver/src/devicedrv/ump linux/drivers/gpu/arm/
    cp -apP meson_gx_mali_450/driver/src/devicedrv/umplock linux/drivers/gpu/arm/
    #cp -apP meson_gx_mali_450/driver/src/ump/include linux/drivers/gpu/arm/ump/
    cp -apP meson_gx_mali_450/driver/src/ump/include/ump linux/include/
  fi

  if ! grep -q CONFIG_MALI400 ${KDIR}/${defcfg} ; then
    cat <<EOFMALIDEFCFG | tee -a ${KDIR}/${defcfg}

CONFIG_MALI400=m
CONFIG_MALI450=y
# CONFIG_MALI470 is not set
# CONFIG_MALI400_DEBUG is not set
# CONFIG_MALI400_PROFILING is not set
CONFIG_MALI400_UMP=y
# CONFIG_MALI_DVFS is not set
CONFIG_MALI_DMA_BUF_MAP_ON_ATTACH=y
# CONFIG_MALI_SHARED_INTERRUPTS is not set
# CONFIG_MALI_PMU_PARALLEL_POWER_UP is not set
# CONFIG_MALI_DT is not set
# CONFIG_MALI_DEVFREQ is not set
# CONFIG_MALI_QUIET is not set
EOFMALIDEFCFG
  fi

  if ! grep -q CONFIG_UMP ${KDIR}/${defcfg} ; then
    cat <<EOFUMPDEFCFG | tee -a ${KDIR}/${defcfg}

CONFIG_UMP=y
# CONFIG_UMP_DEBUG is not set
EOFUMPDEFCFG
  fi

  sed -i s/CONFIG_ARCH_EXYNOS4/CONFIG_ARCH_MESON/g ${KDIR}/drivers/gpu/arm/mali/Kbuild
  sed -i s/exynos4/meson/g ${KDIR}/drivers/gpu/arm/mali/Kbuild

  if [ ! -e ${KDIR}/drivers/gpu/arm/Kconfig ]; then
    touch ${KDIR}/drivers/gpu/arm/Kconfig
  fi
  if ! grep -q 'arm/mali/' ${KDIR}/drivers/gpu/arm/Kconfig ; then
    echo 'source "drivers/gpu/arm/mali/Kconfig"' >> ${KDIR}/drivers/gpu/arm/Kconfig
  fi
  if ! grep -q 'arm/ump/' ${KDIR}/drivers/gpu/arm/Kconfig ; then
    echo 'source "drivers/gpu/arm/ump/Kconfig"' >> ${KDIR}/drivers/gpu/arm/Kconfig
  fi

  if [ ! -e ${KDIR}/drivers/gpu/arm/Makefile ]; then
    touch ${KDIR}/drivers/gpu/arm/Makefile
  fi
  if ! grep -q 'mali/' ${KDIR}/drivers/gpu/arm/Makefile ; then
    echo 'obj-$(CONFIG_MALI400) += mali/' >> ${KDIR}/drivers/gpu/arm/Makefile
  fi
  if ! grep -q 'ump/' ${KDIR}/drivers/gpu/arm/Makefile ; then
    echo 'obj-$(CONFIG_UMP) += ump/' >> ${KDIR}/drivers/gpu/arm/Makefile
  fi
  if ! grep -q 'umplock/' ${KDIR}/drivers/gpu/arm/Makefile ; then
    echo 'obj-$(CONFIG_UMP) += umplock/' >> ${KDIR}/drivers/gpu/arm/Makefile
  fi

  if ! grep -q 'gpu/arm/' ${KDIR}/drivers/video/Kconfig ; then
    echo 'source "drivers/gpu/arm/Kconfig"' >> ${KDIR}/drivers/video/Kconfig
  fi

  if ! grep -q 'arm/' ${KDIR}/drivers/gpu/Makefile ; then
    echo 'obj-y += arm/' >> ${KDIR}/drivers/gpu/Makefile
  fi
fi

echo OK
